﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSplitBegin(string infile,string password);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSplit(int id,string output,int mode,string range);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSplitEnd(int id);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeBegin();

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeSetFiles(int id,string infile,string password,string range);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMerge(int id,string outfile);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MMergeEnd(int id);

        [DllImport("pdfsplitmerge", CallingConvention = CallingConvention.StdCall)]
        public static extern int MWatermark(int id, string text, int fsize, int fcolor, int position, int angle, int xoff, int yoff, int asbackground);
       
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
	        int id = MSplitBegin("test.pdf","");
	        if(id==-1){
		        MessageBox.Show("PDF file unexist or damaged!");
		        return;
	        }
	        if(id==-2){
		        MessageBox.Show("PDF file is restricted!");
		        return;
	        }
	
	        int mode = 1;
	        MSplit(id,"split",mode,"");

	        MSplitEnd(id);
            MessageBox.Show("Split finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int id = MSplitBegin("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            int mode = 2;
            MSplit(id, "Deleted.pdf", mode, "3-8");

            MSplitEnd(id);
            MessageBox.Show("Delete finished!");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int id = MSplitBegin("test.pdf", "");
            if (id == -1)
            {
                MessageBox.Show("PDF file unexist or damaged!");
                return;
            }
            if (id == -2)
            {
                MessageBox.Show("PDF file is restricted!");
                return;
            }

            int mode = 3;
            MSplit(id, "Extract.pdf", mode, "3-8,9,15");

            MSplitEnd(id);
            MessageBox.Show("Extract finished!");
        }

        private void button4_Click(object sender, EventArgs e)
        {
	        int id = MMergeBegin();
	        if(id<=0){
		        MessageBox.Show("Creat PDF file failed!");
		        return;
	        }

	        MMergeSetFiles(id,"test.pdf","","1-3");
            MMergeSetFiles(id, "test.pdf", "", "5");
            MMergeSetFiles(id, "test.pdf", "", "7-9");

            int fsize = 16;
            int fcolor = 255;//red
            int position = 2;//Top-Center
            int angle = 0;
            int xoff = 0;
            int yoff = 0;
            int asbackground = 0;
            //Stamping
            MWatermark(id, "Merge into one pdf file", fsize, fcolor, position, angle, xoff, yoff, asbackground);

	        MMerge(id,"Merged.pdf");
	
	        MMergeEnd(id);

            MessageBox.Show("Merge finished!");
        }
    }
}
